(function(){suite("djblets/configForms/models/ListItem",function(){describe("Default actions",function(){describe("showRemove",function(){it("true",function(){var listItem=new Djblets.Config.ListItem({showRemove:true});expect(listItem.actions.length).toBe(1);expect(listItem.actions[0].id).toBe("delete")});it("false",function(){var listItem=new Djblets.Config.ListItem({showRemove:false});expect(listItem.actions.length).toBe(0)})})})});suite("djblets/configForms/views/ListItemView",function(){describe("Rendering",function(){describe("Item display",function(){it("With editURL",function(){var item=new Djblets.Config.ListItem({editURL:"http://example.com/",text:"Label"}),itemView=new Djblets.Config.ListItemView({model:item});itemView.render();expect(itemView.$el.html().strip()).toBe('<span class="config-forms-list-item-actions"></span>'+'<a href="http://example.com/">Label</a>')});it("Without editURL",function(){var item=new Djblets.Config.ListItem({text:"Label"}),itemView=new Djblets.Config.ListItemView({model:item});itemView.render();expect(itemView.$el.html().strip()).toBe('<span class="config-forms-list-item-actions"></span>'+"Label")})});describe("Actions",function(){describe("Buttons",function(){it("Simple",function(){var item=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),itemView=new Djblets.Config.ListItemView({model:item}),$button;itemView.render();$button=itemView.$(".btn");expect($button.length).toBe(1);expect($button.text()).toBe("Button");expect($button.hasClass("config-forms-list-action-mybutton")).toBe(true);expect($button.hasClass("rb-icon")).toBe(false);expect($button.hasClass("danger")).toBe(false)});it("Danger",function(){var item=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button",danger:true}]}),itemView=new Djblets.Config.ListItemView({model:item}),$button;itemView.render();$button=itemView.$(".btn");expect($button.length).toBe(1);expect($button.text()).toBe("Button");expect($button.hasClass("config-forms-list-action-mybutton")).toBe(true);expect($button.hasClass("rb-icon")).toBe(false);expect($button.hasClass("danger")).toBe(true)});it("Icon names",function(){var item=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button",danger:false,iconName:"foo"}]}),itemView=new Djblets.Config.ListItemView({model:item}),$button,$span;itemView.render();$button=itemView.$(".btn");expect($button.length).toBe(1);expect($button.text()).toBe("Button");expect($button.hasClass("config-forms-list-action-mybutton")).toBe(true);expect($button.hasClass("danger")).toBe(false);$span=$button.find("span");expect($span.length).toBe(1);expect($span.hasClass("djblets-icon")).toBe(true);expect($span.hasClass("djblets-icon-foo")).toBe(true)})});it("Checkboxes",function(){var item=new Djblets.Config.ListItem({text:"Label",checkboxAttr:false,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",propName:"checkboxAttr"}]}),itemView=new Djblets.Config.ListItemView({model:item});itemView.render();expect(itemView.$("input[type=checkbox]").length).toBe(1);expect(itemView.$("label").length).toBe(1)});it("Menus",function(){var item=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mymenu",label:"Menu",children:[{id:"mymenuitem",label:"My menu item"}]}]}),itemView=new Djblets.Config.ListItemView({model:item}),$button;itemView.render();$button=itemView.$(".btn");expect($button.length).toBe(1);expect($button.text()).toBe("Menu ▾")})})});describe("Action handlers",function(){it("Buttons",function(){var item=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),itemView=new Djblets.Config.ListItemView({model:item}),$button;itemView.actionHandlers={mybutton:"_onMyButtonClick"};itemView._onMyButtonClick=function(){};spyOn(itemView,"_onMyButtonClick");itemView.render();$button=itemView.$(".btn");expect($button.length).toBe(1);$button.click();expect(itemView._onMyButtonClick).toHaveBeenCalled()});it("Checkboxes",function(){var item=new Djblets.Config.ListItem({text:"Label",checkboxAttr:false,actions:[{id:"mycheckbox",type:"checkbox",label:"Checkbox",propName:"checkboxAttr"}]}),itemView=new Djblets.Config.ListItemView({model:item}),$checkbox;itemView.actionHandlers={mybutton:"_onMyButtonClick"};itemView._onMyButtonClick=function(){};spyOn(itemView,"_onMyButtonClick");itemView.render();$checkbox=itemView.$("input[type=checkbox]");expect($checkbox.length).toBe(1);expect($checkbox.prop("checked")).toBe(false);$checkbox.prop("checked",true).triggerHandler("change");expect(item.get("checkboxAttr")).toBe(true)})})});suite("djblets/configForms/views/ListView",function(){describe("Manages items",function(){var collection,list,listView;beforeEach(function(){collection=new Backbone.Collection([{text:"Item 1"},{text:"Item 2"},{text:"Item 3"}],{model:Djblets.Config.ListItem});list=new Djblets.Config.List({},{collection:collection});listView=new Djblets.Config.ListView({model:list});listView.render()});it("On render",function(){var $items;$items=listView.$("li");expect($items.length).toBe(3);expect($items.eq(0).text().strip()).toBe("Item 1");expect($items.eq(1).text().strip()).toBe("Item 2");expect($items.eq(2).text().strip()).toBe("Item 3")});it("On add",function(){var $items;collection.add({text:"Item 4"});$items=listView.$("li");expect($items.length).toBe(4);expect($items.eq(3).text().strip()).toBe("Item 4")});it("On remove",function(){var $items;collection.remove(collection.at(0));$items=listView.$("li");expect($items.length).toBe(2);expect($items.eq(0).text().strip()).toBe("Item 2")});it("On reset",function(){var $items;collection.reset([{text:"Foo"},{text:"Bar"}]);$items=listView.$("li");expect($items.length).toBe(2);expect($items.eq(0).text().strip()).toBe("Foo");expect($items.eq(1).text().strip()).toBe("Bar")})})});suite("djblets/configForms/views/TableItemView",function(){describe("Rendering",function(){describe("Item display",function(){it("With editURL",function(){var item=new Djblets.Config.ListItem({editURL:"http://example.com/",text:"Label"}),itemView=new Djblets.Config.TableItemView({model:item});itemView.render();expect(itemView.$el.html().strip()).toBe("<td>"+'<span class="config-forms-list-item-actions"></span>'+'<a href="http://example.com/">Label</a>'+"</td>")});it("Without editURL",function(){var item=new Djblets.Config.ListItem({text:"Label"}),itemView=new Djblets.Config.TableItemView({model:item});itemView.render();expect(itemView.$el.html().strip()).toBe("<td>"+'<span class="config-forms-list-item-actions"></span>'+"Label"+"</td>")})});describe("Action placement",function(){it("Default template",function(){var item=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),itemView=new Djblets.Config.TableItemView({model:item}),$button;itemView.render();$button=itemView.$("td:last .btn");expect($button.length).toBe(1);expect($button.text()).toBe("Button")});it("Custom template",function(){var CustomTableItemView=Djblets.Config.TableItemView.extend({template:_.template(["<td></td>","<td></td>"].join(""))}),item=new Djblets.Config.ListItem({text:"Label",actions:[{id:"mybutton",label:"Button"}]}),itemView=new CustomTableItemView({model:item}),$button;itemView.render();$button=itemView.$("td:last .btn");expect($button.length).toBe(1);expect($button.text()).toBe("Button")})})})});suite("djblets/configForms/views/TableView",function(){describe("Manages rows",function(){var collection,list,tableView;beforeEach(function(){collection=new Backbone.Collection([{text:"Item 1"},{text:"Item 2"},{text:"Item 3"}],{model:Djblets.Config.ListItem});list=new Djblets.Config.List({},{collection:collection});tableView=new Djblets.Config.TableView({model:list});tableView.render()});it("On render",function(){var $rows;$rows=tableView.$("tr");expect($rows.length).toBe(3);expect($rows.eq(0).text().strip()).toBe("Item 1");expect($rows.eq(1).text().strip()).toBe("Item 2");expect($rows.eq(2).text().strip()).toBe("Item 3")});it("On add",function(){var $rows;collection.add({text:"Item 4"});$rows=tableView.$("tr");expect($rows.length).toBe(4);expect($rows.eq(3).text().strip()).toBe("Item 4")});it("On remove",function(){var $rows;collection.remove(collection.at(0));$rows=tableView.$("tr");expect($rows.length).toBe(2);expect($rows.eq(0).text().strip()).toBe("Item 2")});it("On reset",function(){var $rows;collection.reset([{text:"Foo"},{text:"Bar"}]);$rows=tableView.$("tr");expect($rows.length).toBe(2);expect($rows.eq(0).text().strip()).toBe("Foo");expect($rows.eq(1).text().strip()).toBe("Bar")})})})}).call(this);